package explorviz.live_trace_processing.filter.counting;

import explorviz.live_trace_processing.filter.AbstractFilter;
import explorviz.live_trace_processing.filter.IPipeReceiver;
import explorviz.live_trace_processing.record.IRecord;
import explorviz.live_trace_processing.record.event.AbstractEventRecord;
import explorviz.live_trace_processing.record.trace.Trace;

public class RecordCountingFilter extends AbstractFilter implements IRecordCounting {

	public RecordCountingFilter(final IPipeReceiver receiver) {
		super(receiver, 16, 64, "Records/sec");
		counter.setEnabled(false);
	}

	@Override
	public void processRecord(final IRecord record) {
		if (record instanceof Trace) {
			final Trace trace = (Trace) record;
			if (trace.isValid()) {
				counter.inputObjectsCount(trace.getTraceEvents().size());
			}
		} else if (record instanceof AbstractEventRecord) {
			counter.inputObjectsCount(1);
		} else {
			deliver(record);
		}
	}
}
